# Generated by Django 4.2.8 on 2024-01-02 11:33

import constrainedfilefield.fields.file
from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        ('clients', '0001_initial'),
    ]

    operations = [
        migrations.CreateModel(
            name='Audit',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('title_ar', models.CharField(max_length=512, verbose_name='Title (AR)')),
                ('title_en', models.CharField(max_length=512, verbose_name='Title (EN)')),
                ('description_ar', models.TextField(verbose_name='Description (AR)')),
                ('description_en', models.TextField(verbose_name='Description (EN)')),
                ('type', models.CharField(choices=[('RESTAURANTS', 'Restaurants'), ('HOTELS', 'Hotels'), ('MISC', 'Miscellaneous')], max_length=128, verbose_name='Type')),
                ('created_on', models.DateTimeField(auto_now_add=True, null=True, verbose_name='Created On')),
                ('updated_on', models.DateTimeField(auto_now=True, null=True, verbose_name='Updated On')),
                ('created_by', models.ForeignKey(null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='audits', to=settings.AUTH_USER_MODEL, verbose_name='Created By')),
                ('created_for', models.ForeignKey(null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='audits', to='clients.organization', verbose_name='Created For')),
                ('derived_from', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='driven_audits', to='assessment.audit', verbose_name='Derived From')),
                ('updated_by', models.ForeignKey(null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='updated_audits', to=settings.AUTH_USER_MODEL, verbose_name='Updated By')),
            ],
        ),
        migrations.CreateModel(
            name='Section',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('path', models.CharField(max_length=255, unique=True)),
                ('depth', models.PositiveIntegerField()),
                ('numchild', models.PositiveIntegerField(default=0)),
                ('title_ar', models.CharField(max_length=256, verbose_name='Title (AR)')),
                ('title_en', models.CharField(max_length=256, verbose_name='Title (EN)')),
                ('display_order', models.PositiveSmallIntegerField(blank=True, null=True, verbose_name='Display Order')),
                ('show_flag', models.BooleanField(blank=True, default=True, verbose_name='Show?')),
                ('sub_of', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='sub_sections', to='assessment.section', verbose_name='Sub of')),
            ],
            options={
                'ordering': ('display_order', 'title_en'),
            },
        ),
        migrations.CreateModel(
            name='Question',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('prompt_ar', models.TextField(blank=True, verbose_name='Prompt (AR)')),
                ('prompt_en', models.TextField(verbose_name='Prompt (EN)')),
                ('help_text_ar', models.TextField(blank=True, verbose_name='Help Text (AR)')),
                ('help_text_en', models.TextField(blank=True, verbose_name='Help Text (EN)')),
                ('display_order', models.PositiveSmallIntegerField(blank=True, null=True, verbose_name='Display Order')),
                ('audit', models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, related_name='questions', to='assessment.audit', verbose_name='Audit')),
                ('section', models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, related_name='questions', to='assessment.section', verbose_name='Section')),
            ],
            options={
                'ordering': ('audit', 'section', 'display_order'),
            },
        ),
        migrations.CreateModel(
            name='Evidence',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('uploaded_file', constrainedfilefield.fields.file.ConstrainedFileField(content_types=['application/pdf', 'image/png', 'image/bmp', 'image/jpg', 'image/jpeg', 'image/gif'], max_upload_size=2000000, mime_lookup_length=4096, null=True, upload_to='evidence')),
                ('notes', models.TextField(blank=True, verbose_name='Notes')),
                ('type', models.CharField(choices=[('PICTURE', 'Picture'), ('VIDEO', 'Video'), ('misc', 'Miscellaneous')], max_length=256, verbose_name='Type')),
                ('uploaded_on', models.DateTimeField(auto_now_add=True, null=True, verbose_name='Uploaded On')),
                ('question', models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, related_name='list_of_evidence', to='assessment.question')),
                ('uploaded_by', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, to=settings.AUTH_USER_MODEL, verbose_name='Uploaded By')),
            ],
        ),
        migrations.CreateModel(
            name='Answer',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('prompt_ar', models.TextField(blank=True, verbose_name='Prompt (AR)')),
                ('prompt_en', models.TextField(verbose_name='Prompt (EN)')),
                ('weight', models.FloatField(blank=True, default=1, help_text='Empty wight indicate N/A answers which are not going to be calculated in the total score', null=True, verbose_name='Weight')),
                ('selected_answer', models.BooleanField(default=False, verbose_name='Selected?')),
                ('display_order', models.PositiveSmallIntegerField(blank=True, null=True, verbose_name='Display Order')),
                ('answered_on', models.DateTimeField(blank=True, null=True, verbose_name='Answered On')),
                ('answered_by', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='answers', to=settings.AUTH_USER_MODEL, verbose_name='Answered By')),
                ('question', models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, related_name='answers', to='assessment.question', verbose_name='Question')),
            ],
            options={
                'ordering': ('question', 'display_order', '-weight'),
            },
        ),
    ]
